/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: file_sky.c,v 0.52 2008/05/23 07:54:36 nsand Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>
#include <netinet/ip_var.h>
#include <netinet/tcp_var.h>

#include <curses.h>

#include "file_sky.h"
#include "convert.h"

extern	u_long MAXTHREADS;
extern char tmp[];
char 	PATH_OK[LENPATH];
char 	PATH_TEMP[LENPATH];
char 	PATH_INCOMPLETE[LENPATH];
char 	PATH_LOG[LENPATH];
FILE 	*flog;
u_long	TIME_LIVE_THREAD;
u_long	TIME_LIVE_BEGIN;
u_long	TIME_END_FILE;
extern		struct share_value *sharedb;
extern     struct pks *db;
extern     struct filter *filterdb;
extern     struct filterdbt *dbt;
extern     struct filterdbb *dbb;

u_short NOCOMPLETE;
char src[SRCDSTSIZE];
char dst[SRCDSTSIZE];
	u_int64_t gx,gy,goffset;
    u_int64_t pos=0LL;
    u_long refer;
	u_long i;
	struct crossxy xy;
    
//	u_int64_t fx,fy,d;
  //  u_long posik;
    
/*
*  delete file and clear PKS in DB
*/
void
DelFile(u_long ref) {

	if (close(db[ref].fd) != 0)	Logger("DelFile: Error close file\n");

    bzero(src,SRCDSTSIZE);
    sprintf(src,"%s/%s",PATH_TEMP,db[ref].name);	
    if (remove(src))			Logger("DelFile: error remove file\n");

	sharedb->openfiles--;
    DelWritraf(db[ref].lencur);
    ClearTree(ref);
}


/*
* The full file is transferable in directory PATH_OK
*
*/
int 
FileFull(u_long num)
{
    u_long ref=0;
	int i;
    bzero(&src[0],SRCDSTSIZE);    bzero(&dst[0],SRCDSTSIZE);
    if (db[num].refer < MAXTHREADS) ref=db[num].refer;
	else ref=num;

    ClearTMP();
    struct stat dr;
    umask(0);
    sprintf(tmp,"%s/%s",PATH_OK,db[ref].type);	
    if (stat(tmp,&dr) != 0) mkdir(tmp,00777);

    sprintf(src,"%s/%s",PATH_TEMP,db[ref].name);
    /* if not found ext in name, then added.*/    
    if (db[ref].findname[0] != 0) {
		if (sharedb->codepage[0] != 255) {
		for (i=0; i<strlen(db[ref].findname); i++)
			db[ref].findname[i] = Convert(db[ref].findname[i],sharedb->codepage[0],sharedb->codepage[1]);
		}

		if (strcasestr(db[ref].findname,db[ref].type) != NULL)
	     sprintf(dst,"%s/%s/%08x_%s",PATH_OK,db[ref].type,db[ref].dst,db[ref].findname);
		else sprintf(dst,"%s/%s/%08x_%s.%s",PATH_OK,db[ref].type,db[ref].dst,db[ref].findname,db[ref].type);
    } else {
	sprintf(dst,"%s/%s/%08x_%s_%x_%x_%x.%s",PATH_OK,db[ref].type,db[ref].dst, inet_ntoa(db[ref].src),db[ref].port_s,db[ref].port_d,db[ref].ack,db[ref].type);
    }
    
    if (close(db[ref].fd) != 0) Logger("FileFull: close error\n");
	else sharedb->openfiles--;

    if (rename(src,dst)) Logger("FileFull: error rename file\n");
    ClearTree(ref);    
return 0;
}


/*
* We delete from base a stream from it substream
*
*/
void
ClearTree(u_long ref)
{
    u_long i;

    for (i = 0; i < MAXTHREADS; i++) {
		if (db[i].refer == ref) {
			ClearPKS(i);
			sharedb->countpks--;
		}
    }
    ClearPKS(ref);
    sharedb->countpks--;
}


/*
*  	Data recording in a file with check on concurrence to the written down data
*/
int
WriteData(const char *data_tcp, u_long numpks,u_long lendata,u_long thseq) {
//return 0;
//	u_int64_t gx,gy,goffset;
//    u_int64_t pos=0LL;
//    u_long refer;
//	u_long i;
//struct crossxy xy;
    if (db[numpks].refer < MAXTHREADS) refer = db[numpks].refer;
    else refer = numpks;
    if (lendata == 0L) return 0;	    
    u_long startcount = db[numpks].start_count;
    if (db[numpks].http_offset > 0) {
		db[numpks].start_count += db[numpks].http_offset;
		data_tcp += db[numpks].http_offset;
		lendata  -= db[numpks].http_offset;
		db[numpks].http_offset = 0;
	}
    
    if (thseq >= startcount)  pos = thseq - startcount;
    else pos = thseq + startcount + 1LL; 

    if (pos > 2*GBYTEL) {//    start_count = 4250000000  .   0
	    Logger("WriteData: pos > 2GB\n");
	    return 0;
	    }

    pos += db[numpks].X;
    gx = pos;
    
    if (lendata > 1L) gy = gx + lendata -1LL;
	else gy = gx;  /* may be return 0 */
	xy.x = gx;
	xy.y = gy;
	xy.data = 0LL;	
    xy = CrossedFX2(refer,xy);
	if (xy.data == 4)
		{
		return 0;
		}
    if (db[refer].fd > 2) {  		//        
		lseek(db[refer].fd,pos,SEEK_SET);
		write(db[refer].fd,data_tcp,lendata);
		db[refer].lencur += (xy.y - xy.x) + 1LL;
		AddWritraf((xy.y - xy.x) + 1LL);
		db[refer].countspeed += (xy.y - xy.x) + 1LL;
	} else {Logger("fd < 0  but record to\n");}
    
    time(&db[refer].atime);
    time(&db[numpks].atime);
    if (db[refer].numfx > 20) TruncateMAX(refer);
    if (db[refer].lencur >= db[refer].len)	TruncateMAX(refer);
    
	u_long numfx=db[refer].numfx*2;
	if (db[refer].begin == 0) {
		TruncateMAX(refer);
		for (i=0; i<numfx; i+=2)
		if (db[refer].mas[i] == 0 && db[refer].mas[i+1] > 50LL) {
			db[refer].begin =1;
			if (db[refer].type[0] == 0) ChangeType(refer);
	    }
    }	
return 0;
}


/*
*	Check every TIME_CHECK second stream for fullfile or time endfile
*/
int 
CheckTime(void)
{
    time_t curtime;
    time_t deltatime;
    u_long i = 0;
	time(&curtime);
    for (i = 0; i < MAXTHREADS; i++)
    {
	deltatime = curtime - db[i].atime;
	if (db[i].dst > 0 && (db[i].refer == MAXTHREADS)) {
	    db[i].deltatime = deltatime;
		db[i].rspeed = db[i].countspeed;
		db[i].countspeed = 0;

    	if (db[i].lencur >= db[i].len)	TruncateMAX(i);
	    if (db[i].httpf == 0) {
			if (deltatime > 25) {
	    	    ClearPKS(i);
				sharedb->countpks--;
			}	
			else if ((curtime - db[i].ctime) > 15 )	ClearTree(i);
	    }
	    if (db[i].httpf == 1) {
			if (deltatime >= TIME_END_FILE)		Incomplete(i);
			else if (db[i].fordel == 1)	     		DelFile(i);
			else if (db[i].begin  == 0 && (curtime - db[i].ctime) > TIME_LIVE_BEGIN)	DelFile(i);
			else if (db[i].begin == 1 //&& db[i].lencur == db[i].len 
				 && db[i].mas[0] == 0 && db[i].mas[1] >= (db[i].len -1))	FileFull(i); //    ==
	    }
	}
	else if (db[i].dst > 0 && (db[i].refer > 0 && db[i].refer < MAXTHREADS)) {
			if (db[i].httpf == 1) 
				if (curtime - db[i].atime > TIME_LIVE_THREAD) {
					ClearPKS(i);
					sharedb->countpks--;
				}	
	} 
    }
return 0;
}


/*
* Searches as in the Tetris of collision at the left on the right or full
* overlapping of old data, x-y new block incoming data, fx-fy part data
* in file already wrote.
*     x                   y
*     |-------------------|
* fx  fy    fx fy  fx                      fy
* |----|    |---|  |------------------------|
*/
int
GetPerek(u_int64_t x, u_int64_t y, u_int64_t fx, u_int64_t fy)
{
	 if (x  > fx && x <= fy && y >  fx && y > fy)	return P_LEFT;
    else if (x  < fx && x <  fy && y >= fx && y < fy) 	return P_RIGHT;
    else if (x <= fy && x >= fx && y >= fx && y <= fy) 	return P_IN;
    else if (fx >= x && fy <= y) 			return P_ALL;
    else						return P_NO;
}


/*
*  simple logger messages
*/
void 
Logger(const char *data)
{
    fwrite(data,strlen(data),1,flog);
    fflush(flog);
}


/*
*  To define on the first 100 bytes type of a file and to change it
*/
int 
ChangeType(u_long refer)
{
    db[refer].begin = 1;
    RegExp(refer);
    if (Filter(refer) != 0) 
	{	
	DelFile(refer);
	return 1;
	}
return 0;
}


struct crossxy
CrossedFX2(u_long refer,struct crossxy gxy)
{
    u_int64_t fx=0LL,fy=0LL,d=0LL;
    u_long posik = 0L;
//    fx=0LL,fy=0LL,d=0LL;
  //  posik = 0L;
    int res=0;
    if (gxy.x > gxy.y)    {gxy.data=3;return gxy;}

    if (db[refer].numfx == 0) {
	db[refer].mas[0] = gxy.x;
	db[refer].mas[1] = gxy.y;
		    
	db[refer].numfx++;
	gxy.data=0;
	return gxy;
    }
	u_long numfx=db[refer].numfx*2;
for (posik=0; posik < numfx; posik +=2) { //  <=
    fx = db[refer].mas[posik];
    fy = db[refer].mas[posik + 1];
    if (fx < fy) { 				//    
	res = GetPerek(gxy.x,gxy.y,fx,fy);

	d=0LL;
	switch (res) {
	case P_NO:	break;
	case P_IN:	gxy.data=4;return gxy;		//      
			break;
	case P_LEFT: 	// !!!!!!!!!!		    
			d = (fy - gxy.x) + 1LL;
			gxy.x += d;
			break;

	case P_RIGHT:	
			d = (gxy.y - fx) + 1LL;
			gxy.y -= d;
			break;
			
	case P_ALL:	
			d = (fy - fx) + 1LL;
			db[refer].mas[posik] = db[refer].len; //    
			db[refer].mas[posik + 1] = 0LL;
			db[refer].lencur -=  d;
			break;
		}    // end switch (res)
	    } // fx < fy
    } //FOR

    if (db[refer].mas[posik - 1] == (gxy.x-1LL))
    {
		db[refer].mas[posik - 1] = gxy.y;
    } else {
		db[refer].mas[posik]     = gxy.x;
		db[refer].mas[posik + 1] = gxy.y;
		db[refer].numfx ++;
    }

    if (db[refer].numfx*2 >= (MASSIZE-2)) { 
		db[refer].numfx --;
		gxy.data=2;
		return gxy;
	}
    gxy.data=0;
return gxy;
}


/*
*
*/
int
RegExp(u_long refer)
{
    char buffer[101];
    lseek(db[refer].fd, 0, SEEK_SET);
    read (db[refer].fd, buffer, 100);

    u_long i;
    for (i=0; i<DBTSIZE; i++)
	if (dbb[i].type[0] > 0)
	    if (Ident(buffer,dbb[i].search,dbb[i].type,refer,dbb[i].len) == 0)	return 0;

    bzero(db[refer].type, 32);
    strcpy(db[refer].type,"non");
return 1;
}


int
Ident(char *buffer,const char *search,char *type,u_long refer,u_long len)
{
    u_long i;
    u_char X;
    u_long n;
    u_long m=0;
    u_long s=0;
    char * ps;
    char * uu;
    for (i=0; i < len; i++)
    {
		if ((*buffer == *search) || *search == '.') s++;
			else s=0;
		buffer++;
		search++;
		if (s == len) {
			strcpy(db[refer].type,type);
			return 0;
		}
    }
return 1;    
}


int
FillPKS(const u_long refer)
{
    db[refer].X = GetX(db[refer].http);
    db[refer].len = FileLength(db[refer].http);
    SearchFilename(refer);
    SearchEtag(refer);
    db[refer].refer = SearchOldNameDB(refer);

    if (db[refer].len < 100)// || Filter(refer) != 0)
    	{
		ClearPKS(refer);
		sharedb->countpks--;
		return 1;
	    }
    if (TypeOK(refer) == 0)
    if (Filter(refer) != 0) 
	    {	
		ClearPKS(refer);
		sharedb->countpks--;
		return 1;
	    }
    if (db[refer].refer == MAXTHREADS) {
	AddFile(refer);
    }
}


void
AddFile(const u_long refer)
{
    char path[300];    
    bzero(path,300);

    if (db[refer].refer == MAXTHREADS) {
	umask(0);
	sprintf(path,"%s/%s",PATH_TEMP,db[refer].name);
	db[refer].fd = open(path,O_RDWR | O_CREAT,00666);
	if (db[refer].fd == -1) {
	    ClearPKS(refer);
	    ClearTMP();
	    sprintf(tmp," error open file fd error: %s\n", strerror(errno));
	    Logger(path);
	    Logger(tmp);
	} else {
		sharedb->openfiles ++; 
	  }
    }
}


void
TruncateMAX(u_long refer)
{
    u_long i,m;
	u_long numfx=db[refer].numfx*2;
    m=0L;
    u_int64_t y,z,y2;
    for(m=0L; m<numfx; m+=2)//<=
    for(i=0L; i<numfx; i+=2) { //<=
	y = db[refer].mas[m+1] + 1LL;
	y2 = db[refer].mas[m+1];
	if (y == db[refer].mas[i] || y2 == db[refer].mas[i])
	if (i != m)
	if (db[refer].mas[i] <= db[refer].mas[i+1])
	if (db[refer].mas[m] <= db[refer].mas[m+1])
	    { 
	    db[refer].mas[m+1] = db[refer].mas[i+1];
	    db[refer].mas[i]   = db[refer].len;
	    db[refer].mas[i+1] = 0L;
	    i=0L;
	    m=0L;
	    } 
    }
TruncateEmpty(refer);
}


void
TruncateEmpty(u_long refer)
{
    u_long g=0L,i;
    u_long numfx=db[refer].numfx*2;
    for(i=0L;i < numfx;i+=2L) { //<=
		if (db[refer].mas[i] < db[refer].mas[i+1]) //  <= [0-0][0-100] 
		{
			db[refer].mas[g] = db[refer].mas[i];
			db[refer].mas[g+1] = db[refer].mas[i+1];
			g+=2L;
		}
    }
	db[refer].numfx = g/2; // -1L
}


void
Incomplete(u_long refer)
{
    if (db[refer].len != 0LL) {

	float pr = ((double)(db[refer].lencur) / ((double)(db[refer].len) * 0.01));

	if (pr < NOCOMPLETE) DelFile(refer);
	else {
	
	    u_long ref=0L;
	    bzero(&src[0],SRCDSTSIZE);    bzero(&dst[0],SRCDSTSIZE);
	    if (db[refer].refer < MAXTHREADS) ref=db[refer].refer;
		else ref=refer;

    	    ClearTMP();
	    struct stat dr;
	    umask(0);
	    sprintf(tmp,"%s/%s",PATH_INCOMPLETE,db[ref].type);	
	    if (stat(tmp,&dr) != 0) mkdir(tmp,00777);

	    sprintf(src,"%s/%s",PATH_TEMP,db[ref].name);
	    
	    if (db[ref].findname[0] !=0) {
			if (sharedb->codepage[0] != 255) {
				int i;
				for (i=0; i<strlen(db[ref].findname); i++)
					db[ref].findname[i] = Convert(db[ref].findname[i],sharedb->codepage[0],sharedb->codepage[1]);
			}
	

		sprintf(dst,"%s/%s/%08x_%s",PATH_INCOMPLETE,db[ref].type,db[ref].dst,db[ref].findname);
	    } else {
		sprintf(dst,"%s/%s/%08x_%08x_%x_%x_%x.%s",PATH_INCOMPLETE,db[ref].type,db[ref].dst, db[ref].src,db[ref].port_s,db[ref].port_d,db[ref].ack,db[ref].type);
		}

	    int res = close(db[ref].fd);
	        if (res != 0) { 
    		    ClearTMP();
		    sprintf(tmp," FileIncomplete db[%u].fd=%d : %s\n", ref,db[ref].fd,strerror(errno));
		    Logger(tmp);
		}

	    sharedb->openfiles--;
		Badtraf(db[ref].lencur);

	    if (rename(src,dst)) { 
    	ClearTMP();
		sprintf(tmp," FileIncomplete rename [src=%s  dst=%s]  error: %s\n", src,dst,strerror(errno));
		Logger(tmp);
	    }
	    ClearTree(ref);    
	}
    } else DelFile(refer);
}


int
TypeOK(u_long refer)
{
    u_long i;
    for (i=0; i<DBTSIZE; i++)
	if (dbt[i].search[0] > 0)
	    if (strcasestr(db[refer].http,dbt[i].search) != NULL) {
			strcpy(db[refer].type,dbt[i].type);
			return 0;
		}
return 1;
}


void
SetNocomplete(u_long n)
{
    NOCOMPLETE 	= n;
}


void
SetPathOk(char *path)
{
    strcpy(PATH_OK,path);
}


void
SetPathTmp(char *path)
{
    strcpy(PATH_TEMP,path);    
}


void
SetPathInc(char *path)
{
    strcpy(PATH_INCOMPLETE,path);    
}


void
SetPathLog(char *path)
{
    strcpy(PATH_LOG,path);    
}


/*
*   check paths and return 0 if path (ok,temp,incomplete) is exists
*/
int
CheckPaths(void)
{
    struct stat dr;
    if (stat(PATH_OK,&dr) != 0) 	{printf("not found %s\n",PATH_OK); 	  return 1;}
    if (stat(PATH_TEMP,&dr) != 0) 	{printf("not found %s\n",PATH_TEMP);	  return 1;}
    if (stat(PATH_INCOMPLETE,&dr) != 0) {printf("not found %s\n",PATH_INCOMPLETE);return 1;}
    
return 0;
}

int
OpenLog(void)
{
    flog = fopen(PATH_LOG,"w+");
    if (flog == NULL) {
	Logger("error create log file\n"); 
	return 1;
    }
return 0;
}


void
CloseFiles(void)
{
    fclose(flog);
}


u_long
Getopenfiles(void)
{
    return sharedb->openfiles;
}


void
SetTLT(u_long n)
{
 TIME_LIVE_THREAD = n;
}


void
SetTLB(u_long n)
{
 TIME_LIVE_BEGIN = n;
}


void
SetTEF(u_long n)
{
 TIME_END_FILE = n;
}

