/*-
 * Copyright (c) 2008 Andrey V. Surkov <nsand@sura.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	 $Id: sky_node.c,v 0.52 2008/09/18 07:54:36 nsand Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>

#include <sys/time.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/linker.h>
#include <sys/types.h>

#include <netgraph.h>


#include "my_types.h"
#include "sky_shm.h"

int
Shm_open(const char *pathname, int oflag, mode_t mode)
{
	int		fd;

	if ( (fd = shm_open(pathname, oflag, mode)) == -1)
		printf("shm_open error for %s", pathname);
	return(fd);
}

void
Ftruncate(int fd, off_t length)
{
	if (ftruncate(fd, length) == -1)
		printf("ftruncate error");
}

void *
Mmap(void *addr, size_t len, int prot, int flags, int fd, off_t offset)
{
	void	*ptr;
	if ( (ptr = mmap(addr, len, prot, flags, fd, offset)) == MAP_FAILED)
		printf("mmap error");
	return(ptr);
}



void
Fstat(int fd, struct stat *ptr)
{
	if (fstat(fd, ptr) == -1)
		printf("fstat error\n");
}

void
Close(int fd)
{
	if (close(fd) == -1)
	printf("close error");
}

int
read_shm(int argc, char **argv)
{
	int		i, fd;
	struct stat	stat;
	struct filter *ft;
		/* 4open, get size, map */
	fd = Shm_open("skyfishshm", O_RDONLY, FILE_MODE);
	Fstat(fd, &stat);
	ft = Mmap(NULL, sizeof(struct filter), PROT_READ,
			   MAP_SHARED, fd, 0);
	Close(fd);
	for (i=0;i<20;i++)
	printf("%s  %llu  %llu\n",ft[i].type, ft[i].min, ft[i].max);

	printf("summ = %lu",sizeof(struct pks));
return 0;
}

void
Shm_unlink(const char *pathname)
{
	if (shm_unlink(pathname) == -1)	;
	//	err_sys("shm_unlink error");
}


int
write_shm(void)
{
	int		i, fd;
	struct stat	stat;
	struct filter *ptr;

	fd = Shm_open("skyfishshm", O_RDWR, FILE_MODE);
	Fstat(fd, &stat);
	ptr = Mmap(NULL, FILTERBUFFER * sizeof(struct filter), PROT_READ | PROT_WRITE,
			   MAP_SHARED, fd, 0);
	Close(fd);

		memcpy(ptr,filterdb,FILTERBUFFER * sizeof(struct filter));
	return 0;
}

